const _ = require("lodash")
const fs = require("fs")
const term = require("terminal-kit").terminal;
const express = require('express');
const path = require("path");
const EventEmitter = require("events");
const EE = new EventEmitter();
const app = express()
const port = 8000
var progressBar;





EE.on('ErrorFound', (ErrorName, ErrorCode, ErrorReason) => {
    term.red("🔴 >> Error Found : " + ErrorName + " : " + ErrorCode + "\tError Reason : " + ErrorReason)
});

EE.on('connected', (Port, HostName) => {
    term.blue("🧱 >> Connected to http://" + HostName + ":" + Port)
})

let settings = {
    "homepageFile": null,
    "404Page": null
}



// app.use(function(req, res) {
//     if (req.statusCode == '404') {
//         settings["404Page"] == null ?
//             res.sendFile(path.join(__dirname, "./404.html")) :
//             path.isAbsolute(settings["404Page"]) == true ?
//             res.sendFile(path.join(__dirname, settings["404Page"])) :
//             EE.emit("ErrorFound", "Invalid Path", "02", "404 Page File Path is Invalid.")
//     }
// });

app.get('/', (req, res) => {
    settings.homepageFile == null ?
        res.sendFile(path.join(__dirname, "./index.html")) :
        path.isAbsolute(settings.homepageFile) == true ?
        res.sendFile(path.join(__dirname, settings.homepageFile)) :
        EE.emit("ErrorFound", "Invalid Path", "02", "Home Page File Path is Invalid.")
});


function CreateSitePath(PathName, SendingFile) {
    app.get(PathName, (req, res) => {
        res.sendFile(path.join(__dirname, SendingFile))
    })
}

function CreateTemplate(Directory, Name) {
    var p = "./" + Directory + "/" + Name
    fs.mkdirSync(p)
    fs.mkdirSync(`${p}/src`)
    fs.mkdirSync(`${p}/html`)

    fs.writeFileSync(`${p}/src/server.js`, "// Template!!!\nconst http = require(\"lahttp\")\nhttp.settings.homepageFile = \"../html/index.html\"\n// Code")
    fs.writeFileSync(`${p}/html/index.html`, "LaHTTP Template!")


}

module.exports = {
    createPath: CreateSitePath,
    loadTemplate: CreateTemplate,
    Port: port,
    Settings: settings
}

app.listen(port, () => EE.emit("connected", port, "localhost"))